<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');
class Phpfox_Gateway_Api_Paypal implements Phpfox_Gateway_Interface
{
	private $_aParam = array();
	private $_aCurrency = array('USD', 'GBP', 'EUR', 'AUD', 'CAD', 'JPY', 'NZD', 'CHF', 'HKD', 'SGD', 'SEK', 'DKK', 'PLN', 'NOK', 'HUF', 'CZK', 'ILS', 'MXN', 'BRL', 'MYR', 'PHP', 'TWD', 'THB');
	public function __construct()
	{
		session_start();
	}	
	
	public function set($aSetting)
	{
		$this->_aParam = $aSetting;
		
		if (Phpfox::getLib('parse.format')->isSerialized($aSetting['setting']))
		{
			$this->_aParam['setting'] = unserialize($aSetting['setting']);
		}
	}
	
	public function getEditForm()
	{
		return array(
			'bitpay_api' => array(
				'phrase' => 'bitpay API Code',
				'phrase_info' => 'The API code that represents your bitpay gateway.',
				'value' => (isset($this->_aParam['setting']['bitpay_api']) ? $this->_aParam['setting']['bitpay_api'] : '')
			)
		);
	}
	
	public function getForm()
	{
		if (!in_array($this->_aParam['currency_code'], $this->_aCurrency))
		{
			if (isset($this->_aParam['alternative_cost']))
			{
				$aCosts = unserialize($this->_aParam['alternative_cost']);
				$bPassed = false;
				foreach ($aCosts as $sCode => $iPrice)
				{
					if (in_array($sCode, $this->_aCurrency))
					{
						$this->_aParam['amount'] = $iPrice;
						$this->_aParam['currency_code'] = $sCode;
						$bPassed = true;
						break;
					}
				}

				if ($bPassed === false)
				{
					return false;
				}
			}
			else
			{
				return false;
			}
		}

        $api = $this->_aParam['setting']['bitpay_api'];
        $amount = $this->_aParam['amount'];
        $ReturnPath =  urlencode(Phpfox::getLib('gateway')->url('paypal'));//$this->_aParam['return_P'];
		
		Phpfox::setCookie('ResNumber',($this->_aParam['item_number'].'|'.$amount));
		
		$url = 'https://bitpay.ir/payment/gateway-send';
		$result = $this->_send($url,$api,$amount*10,$ReturnPath);
		$go = "https://bitpay.ir/payment/gateway-$result";
		$_SESSION['id_get'] = $result;
        
        if($result > 0 && is_numeric($result)){
            $aForm = array(
			'url' => $go ,
            'param' => array(
				'Price' => '1'
			)
    		);
			//return form with a-palyi-ne
            return $aForm;
        }
        else
        {
            return false;
        }
	}
	
	public function callback()
	{
		Phpfox::log('Starting bitpay callback');

        $messagePage = '<html xmlns="http://www.w3.org/1999/xhtml">
        <head runat="server">
            <title>نتيجه پرداخت </title>
            <meta http-equiv="Content-Type" content="Type=text/html; charset=utf-8" />
        </head>
        <body style="text-align:center">
            <br/><br/><br/><br/>
            <div style="border: 1px solid;margin:auto;padding:15px 10px 15px 50px; width:600px;font-size:8pt; line-height:25px;$Style$">
             $Message$
            </div> <br /></br> <a href="/index.php" style="font:size:8pt ; color:#333333; font-family:tahoma; font-size:7pt" >بازگشت به صفحه اصلي</a>
        </body>
        </html>';

        $style = 'font-family:tahoma; text-align:right; direction:rtl';
        $style_succ = 'color: #4F8A10;background-color: #DFF2BF;'.$style;
        $style_alrt = 'color: #9F6000;background-color: #FEEFB3;'.$style;
        $style_errr = 'color: #D8000C;background-color: #FFBABA;'.$style;

        $api = $this->_aParam['setting']['bitpay_api'];
        $aParts = explode('|',Phpfox::getCookie('ResNumber'));
        $Price = $aParts[2];

        Phpfox::log('Attempting callback');
		$url = 'https://bitpay.ir/payment/gateway-result-second';
		$trans_id = $_POST['trans_id'];
		$id_get = $_POST['id_get'];
        if(is_numeric($id_get) && is_numeric($trans_id) && ($id_get == $this->_aParam['id_get']))
        {
        		$result = $this->_get($url,$api,$trans_id,$id_get);
        		if($result == 1)// Your Peyment Code Only This Event
        		{
                    Phpfox::log('Callback OK');

                    Phpfox::log('Attempting to load module: ' . $aParts[0]);

        			if (Phpfox::isModule($aParts[0]))
        			{
        				Phpfox::log('Module is valid.');
        				Phpfox::log('Checking module callback for method: paymentApiCallback');
        				if (Phpfox::hasCallback($aParts[0], 'paymentApiCallback'))
        				{
        					Phpfox::log('Module callback is valid.');

        			  		$sStatus = 'completed';

        					Phpfox::log('Status built: ' . $sStatus);

      						Phpfox::log('Executing module callback');
      						Phpfox::callback($aParts[0] . '.paymentApiCallback', array(
      								'gateway' => 'paypal',
      								'ref' => $trans_id,
      								'status' => $sStatus,
      								'item_number' => $aParts[1],
      								'total_paid' => $Price
      							)
      						);
      						header('HTTP/1.1 200 OK');
                            $mss = 'کاربر گرامي ، عمليات پرداخت با موفقيت به پايان رسيد .<br><br>جهت پيگيري هاي آتي شماره رسيد پرداخت خود را ياداشت فرماييد : '.$trans_id.'<br> با تشکر <br>';
                            $messagePage = str_replace('$Message$',$mss,$messagePage);
                            $messagePage = str_replace('$Style$',$style_succ,$messagePage);
                            echo $messagePage;

                            return;
        				}
        				else
        				{
        					Phpfox::log('Module callback is not valid.');
        				}
        			}
        			else
        			{
        				Phpfox::log('Module is not valid.');
        			}
        		}
        		else
        		{
        			Phpfox::log('Callback '.$Status);
                   	$sStatus = $Status;
                    $mss = 'کاربر گرامي ، عمليات  اعتبار سنجي پرداخت شما با خطا مواجه گرديد .<br> درصورتي که پرداخت شما موفقيت آميز انجام شده باشد پس از بررسي اطلاعات پرداخت براي شما ارسال خواهد شد . <br> با تشکر <br> شماره پیگیری: '.$trans_id;
                    $messagePage = str_replace('$Message$',$mss,$messagePage);
                    $messagePage = str_replace('$Style$',$style_alrt,$messagePage);
                    echo $messagePage;
                    return;
        		}
	        }
          	else
      		{
      			Phpfox::log('Callback FAILED');
                $sStatus = 'cancel';
                header('HTTP/1.1 200 OK');
      		}
            $mss = 'پرداخت ناموفق / خطا در عمليات پرداخت ! کاربر گرامي ، فرايند پرداخت با خطا مواجه گرديد !<br> با تشکر <br>شماره پیگیری : '.$trans_id;
            $messagePage = str_replace('$Message$',$mss,$messagePage);
            $messagePage = str_replace('$Style$',$style_errr,$messagePage);
            echo $messagePage;
    }
	
	public function _send($url,$api,$amount,$redirect){
		$ch = curl_init();
		curl_setopt($ch,CURLOPT_URL,$url);
		curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&amount=$amount&redirect=$redirect");
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
		$res = curl_exec($ch);
		curl_close($ch);
		return $res;
	}
	public function _get($url,$api,$trans_id,$id_get){
		$ch = curl_init();
		curl_setopt($ch,CURLOPT_URL,$url);
		curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&id_get=$id_get&trans_id=$trans_id");
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
		$res = curl_exec($ch);
		curl_close($ch);
		return $res;
	}
}
?>